package dtgateway

import (
	"GtDataStore/app/cmd/organization/pb"
	"GtDataStore/common/xerr"
	"context"

	"GtDataStore/app/cmd/dtgateway/internal/svc"
	"GtDataStore/app/cmd/dtgateway/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type WorkingUfByCycleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewWorkingUfByCycleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *WorkingUfByCycleLogic {
	return &WorkingUfByCycleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *WorkingUfByCycleLogic) WorkingUfByCycle(req *types.WorkingUfByCycleReq) (resp *types.CommonResponse, err error) {
	list, err := l.svcCtx.OrganizationRpc.FindWorkingUfByCycle(l.ctx, &pb.FindWorkingUfByCycleReq{
		ProjectId:       req.ProjectId,
		DeviceCode:      req.DeviceCode,
		FilterCycle:     req.FilterCycle,
		Step:            req.Step,
		FilterTimeStart: req.FilterTimeStart,
		FilterTimeEnd:   req.FilterTimeEnd,
		Limit:           req.Limit,
	})
	if err != nil {
		return nil, err
	}

	return &types.CommonResponse{
		Code: xerr.OK,
		Msg:  xerr.MapErrMsg(xerr.OK),
		Data: list,
	}, nil
}
